Attribute VB_Name = "ColorPicker"
Option Explicit

Public Type ChooseColorStruct
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (lpChoosecolor As ChooseColorStruct) As Long
Public Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

Public Const CC_RGBINIT = &H1&
Public Const CC_FULLOPEN = &H2&
Public Const CC_PREVENTFULLOPEN = &H4&
Public Const CC_SHOWHELP = &H8&
Public Const CC_ENABLEHOOK = &H10&
Public Const CC_ENABLETEMPLATE = &H20&
Public Const CC_ENABLETEMPLATEHANDLE = &H40&
Public Const CC_SOLIDCOLOR = &H80&
Public Const CC_ANYCOLOR = &H100&
Public Const CLR_INVALID = &HFFFF

Public Function ShowColorDialog(Optional ByVal hParent As Long, Optional ByVal bFullOpen As Boolean, Optional ByVal InitColor As OLE_COLOR) As Long

Dim CC As ChooseColorStruct
Dim aColorRef(15) As Long
Dim lInitColor As Long

' translate the initial OLE color to a long value
If InitColor <> 0 Then
    If OleTranslateColor(InitColor, 0, lInitColor) Then
        lInitColor = CLR_INVALID
    End If
End If

'fill the ChooseColorStruct struct
With CC
    .lStructSize = Len(CC)
    .hwndOwner = hParent
    .lpCustColors = VarPtr(aColorRef(0))
    .rgbResult = lInitColor
    .Flags = CC_SOLIDCOLOR Or CC_ANYCOLOR Or CC_RGBINIT Or IIf(bFullOpen, CC_FULLOPEN, 0)
End With

' Show the dialog
If ChooseColor(CC) Then
    'if not canceled, return the color
    ShowColorDialog = CC.rgbResult
Else
    'else return -1
    ShowColorDialog = -1
End If
    
End Function

